Loading...
Searching...
No Matches
openshot::Clip Class Reference

This class represents a clip (used to arrange readers on the timeline) More...

`#include <Clip.h>`

Inheritance diagram for openshot::Clip:

## Public Member Functions

void | AddEffect (openshot::EffectBase *effect)
| Add an effect to the clip.
void | AttachToObject (std::string object_id)
| Attach clip to Tracked Object or to another Clip.
| Clip ()
| Default Constructor.
| Clip (openshot::ReaderBase *new_reader)
| Constructor with reader.
| Clip (std::string path)
| Constructor with filepath (reader is automatically created... by guessing file extensions)
void | Close () override
| Close the internal reader.
std::list< openshot::EffectBase * > | Effects ()
| Return the list of effects on the timeline.
float | End () const override
| Get end position (in seconds) of clip (trim end of video), which can be affected by the time curve.
void | End (float value) override
| Set end position (in seconds) of clip (trim end of video)
Clip * | GetAttachedClip () const
| Return a pointer to the clip this clip is attached to.
std::string | GetAttachedId () const
| Get and set the object id that this clip is attached to.
std::shared_ptr< openshot::TrackedObjectBase > | GetAttachedObject () const
| Return a pointer to the trackedObject this clip is attached to.
openshot::CacheMemory * | GetCache () override
| Get the cache object (always return NULL for this reader)
openshot::EffectBase * | GetEffect (const std::string &id)
| Look up an effect by ID.
std::shared_ptr< openshot::Frame > | GetFrame (int64_t clip_frame_number) override
| Get an openshot::Frame object for a specific frame number of this clip. The image size and number of samples match the source reader.
std::shared_ptr< openshot::Frame > | GetFrame (std::shared_ptr< openshot::Frame > background_frame, int64_t clip_frame_number) override
| Get an openshot::Frame object for a specific frame number of this clip. The image size and number of samples match the background_frame passed in and the timeline (if available).
std::shared_ptr< openshot::Frame > | GetFrame (std::shared_ptr< openshot::Frame > background_frame, int64_t clip_frame_number, openshot::TimelineInfoStruct *options)
| Get an openshot::Frame object for a specific frame number of this clip. The image size and number of samples match the background_frame passed in and the timeline (if available).
bool | IsOpen () override
| Determine if reader is open or closed.
std::string | Json () const override
| Generate JSON string of this object.
Json::Value | JsonValue () const override
| Generate Json::Value for this object.
std::string | Name () override
| Return the type name of the class.
void | Open () override
| Open the internal reader.
openshot::TimelineBase * | ParentTimeline () override
| Get the associated Timeline pointer (if any)
void | ParentTimeline (openshot::TimelineBase *new_timeline) override
| Set associated Timeline pointer.
std::string | PropertiesJSON (int64_t requested_frame) const override
openshot::ReaderBase * | Reader ()
| Get the current reader.
void | Reader (openshot::ReaderBase *new_reader)
| Set the current reader.
void | RemoveEffect (openshot::EffectBase *effect)
| Remove an effect from the clip.
void | SetAttachedClip (Clip *clipObject)
| Set the pointer to the clip this clip is attached to.
void | SetAttachedId (std::string value)
| Set id of the object id that this clip is attached to.
void | SetAttachedObject (std::shared_ptr< openshot::TrackedObjectBase > trackedObject)
| Set the pointer to the trackedObject this clip is attached to.
void | SetJson (const std::string value) override
| Load JSON string into this object.
void | SetJsonValue (const Json::Value root) override
| Load Json::Value into this object.
bool | Waveform ()
| Get the waveform property of this clip.
void | Waveform (bool value)
| Set the waveform property of this clip.
virtual | ~Clip ()
| Destructor.
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip.
float | Duration () const
| Get the length of this clip (in seconds)
std::string | Id () const
| Get the Id of this clip object.
void | Id (std::string value)
int | Layer () const
| Get layer of clip on timeline (lower number is covered by higher numbers)
void | Layer (int value)
| Set layer of clip on timeline (lower number is covered by higher numbers)
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
float | Position () const
| Get position on timeline (in seconds)
void | Position (float value)

> ‍Set the Id of this clip object

float | Start () const
| Get start position (in seconds) of clip (trim start of video)
void | Start (float value)
| Set start position (in seconds) of clip (trim start of video)
virtual | ~ClipBase ()=default
Public Member Functions inherited from openshot::ReaderBase
void | DisplayInfo (std::ostream *out=&std::cout)
| Display file information in the standard output stream (stdout)
openshot::ClipBase * | ParentClip ()
| Parent clip object of this reader (which can be unparented and NULL)
void | ParentClip (openshot::ClipBase *new_clip)
| Set parent clip object of this reader.
| ReaderBase ()
| Constructor for the base reader, where many things are initialized.
virtual | ~ReaderBase ()=default

## Public Attributes

openshot::Keyframe | alpha
| Curve representing the alpha (1 to 0)
openshot::AnchorType | anchor
| The anchor determines what parent a clip should snap to.
openshot::Keyframe | channel_filter
| A number representing an audio channel to filter (clears all other channels)
openshot::Keyframe | channel_mapping
| A number representing an audio channel to output (only works when filtering a channel)
bool | COMPILED_WITH_CV = true
openshot::FrameDisplayType | display
| The format to display the frame number (if any)
openshot::GravityType | gravity
| The gravity of a clip determines where it snaps to its parent.
openshot::Keyframe | has_audio
| An optional override to determine if this clip has audio (-1=undefined, 0=no, 1=yes)
openshot::Keyframe | has_video
| An optional override to determine if this clip has video (-1=undefined, 0=no, 1=yes)
openshot::Keyframe | location_x
| Curve representing the relative X position in percent based on the gravity (-1 to 1)
openshot::Keyframe | location_y
| Curve representing the relative Y position in percent based on the gravity (-1 to 1)
openshot::VolumeMixType | mixing
| What strategy should be followed when mixing audio with other clips.
openshot::Keyframe | origin_x
| Curve representing X origin point (0.0=0% (left), 1.0=100% (right))
openshot::Keyframe | origin_y
| Curve representing Y origin point (0.0=0% (top), 1.0=100% (bottom))
openshot::Keyframe | perspective_c1_x
| Curves representing X for coordinate 1.
openshot::Keyframe | perspective_c1_y
| Curves representing Y for coordinate 1.
openshot::Keyframe | perspective_c2_x
| Curves representing X for coordinate 2.
openshot::Keyframe | perspective_c2_y
| Curves representing Y for coordinate 2.
openshot::Keyframe | perspective_c3_x
| Curves representing X for coordinate 3.
openshot::Keyframe | perspective_c3_y
| Curves representing Y for coordinate 3.
openshot::Keyframe | perspective_c4_x
| Curves representing X for coordinate 4.
openshot::Keyframe | perspective_c4_y
| Curves representing Y for coordinate 4.
openshot::Keyframe | rotation
| Curve representing the rotation (0 to 360)
openshot::ScaleType | scale
| The scale determines how a clip should be resized to fit its parent.
openshot::Keyframe | scale_x
| Curve representing the horizontal scaling in percent (0 to 1)
openshot::Keyframe | scale_y
| Curve representing the vertical scaling in percent (0 to 1)
openshot::Keyframe | shear_x
| Curve representing X shear angle in degrees (-45.0=left, 45.0=right)
openshot::Keyframe | shear_y
| Curve representing Y shear angle in degrees (-45.0=down, 45.0=up)
openshot::Keyframe | time
| Curve representing the frames over time to play (used for speed and direction of video)
openshot::Keyframe | volume
| Curve representing the volume (0 to 1)
openshot::Color | wave_color
| Curve representing the color of the audio wave form.
Public Attributes inherited from openshot::ReaderBase
openshot::ReaderInfo | info
| Information about the current media file.

## Protected Member Functions

void | init_reader_rotation ()
| Update default rotation from reader.
void | init_reader_settings ()
| Init reader info details.
void | init_settings ()
| Init default settings for a clip.
Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (std::string name, int value, int selected_value) const
| Generate JSON choice for a property (dropdown properties)
Json::Value | add_property_json (std::string name, float value, std::string type, std::string memo, const Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame) const
| Generate JSON for a property.

## Protected Attributes

std::recursive_mutex | getFrameMutex
| Mutex for multiple threads.
AudioLocation | previous_location
| Previous time-mapped audio location.
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip)
std::string | id
| ID Property for all derived Clip and Effect classes.
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips.
float | position
| The position on the timeline where this clip should start playing.
std::string | previous_properties
| This string contains the previous JSON properties.
float | start
| The position in seconds to start playing (used to trim the beginning of a clip)
openshot::TimelineBase * | timeline
| Pointer to the parent timeline instance (if any)
Protected Attributes inherited from openshot::ReaderBase
openshot::ClipBase * | clip
| Pointer to the parent clip instance (if any)
std::recursive_mutex | getFrameMutex
| Mutex for multiple threads.

## Detailed Description

This class represents a clip (used to arrange readers on the timeline)

Each image, video, or audio file is represented on a layer as a clip. A clip has many properties that affect how it behaves on the timeline, such as its size, position, transparency, rotation, speed, volume, etc...

// Create some clips
Clip c1(new ImageReader("MyAwesomeLogo.jpeg"));
Clip c2(new FFmpegReader("BackgroundVideo.webm"));
// CLIP 1 (logo) - Set some clip properties (with openshot::Keyframes)
c1.Position(0.0); // Set the position or location (in seconds) on the timeline
c1.gravity = GRAVITY_LEFT; // Set the alignment / gravity of the clip (position on the screen)
c1.scale = SCALE_CROP; // Set the scale mode (how the image is resized to fill the screen)
c1.Layer(1); // Set the layer of the timeline (higher layers cover up images of lower layers)
c1.Start(0.0); // Set the starting position of the video (trim the left side of the video)
c1.End(16.0); // Set the ending position of the video (trim the right side of the video)
c1.alpha.AddPoint(1, 0.0); // Set the alpha to transparent on frame #1
c1.alpha.AddPoint(500, 0.0); // Keep the alpha transparent until frame #500
c1.alpha.AddPoint(565, 1.0); // Animate the alpha from transparent to visible (between frame #501 and #565)
// CLIP 2 (background video) - Set some clip properties (with openshot::Keyframes)
c2.Position(0.0); // Set the position or location (in seconds) on the timeline
c2.Start(10.0); // Set the starting position of the video (trim the left side of the video)
c2.Layer(0); // Set the layer of the timeline (higher layers cover up images of lower layers)
c2.alpha.AddPoint(1, 1.0); // Set the alpha to visible on frame #1
c2.alpha.AddPoint(150, 0.0); // Animate the alpha to transparent (between frame 2 and frame #150)
c2.alpha.AddPoint(360, 0.0, LINEAR); // Keep the alpha transparent until frame #360
c2.alpha.AddPoint(384, 1.0); // Animate the alpha to visible (between frame #360 and frame #384)
openshot::Clip
This class represents a clip (used to arrange readers on the timeline)
Definition Clip.h:89
openshot::FFmpegReader
This class uses the FFmpeg libraries, to open video files and audio files, and return openshot::Frame...
Definition FFmpegReader.h:101
openshot::ImageReader
This class uses the ImageMagick++ libraries, to open image files, and return openshot::Frame objects ...
Definition ImageReader.h:56
openshot::GRAVITY_LEFT
@ GRAVITY_LEFT
Align clip to the left of its parent (middle aligned)
Definition Enums.h:26
openshot::SCALE_CROP
@ SCALE_CROP
Scale the clip until both height and width fill the canvas (cropping the overlap)
Definition Enums.h:37
openshot::LINEAR
@ LINEAR
Linear curves are angular, straight lines between two points.
Definition Point.h:30

Definition at line 89 of file Clip.h.

## Constructor & Destructor Documentation

## Clip() [1/3]

Clip::Clip | ( |  | ) |

Default Constructor.

Definition at line 135 of file Clip.cpp.

## Clip() [2/3]

Clip::Clip | ( | std::string | path | ) |

Constructor with filepath (reader is automatically created... by guessing file extensions)

Parameters

  path | The path of a reader (video file, image file, etc...). The correct reader will be used automatically.

Definition at line 161 of file Clip.cpp.

## Clip() [3/3]

Clip::Clip | ( | openshot::ReaderBase * | new_reader | ) |

Constructor with reader.

Parameters

  new_reader | The reader to be used by this clip

Definition at line 142 of file Clip.cpp.

## ~Clip()

Clip::~Clip | ( |  | ) |

virtual

Destructor.

Definition at line 221 of file Clip.cpp.

## Member Function Documentation

## AddEffect()

void Clip::AddEffect | ( | openshot::EffectBase * | effect | ) |

Add an effect to the clip.

Parameters

  effect | Add an effect to the clip. An effect can modify the audio or video of an openshot::Frame.

Definition at line 1150 of file Clip.cpp.

Referenced by SetJsonValue().

## AttachToObject()

void Clip::AttachToObject | ( | std::string | object_id | ) |

Attach clip to Tracked Object or to another Clip.

Definition at line 241 of file Clip.cpp.

Referenced by SetJsonValue().

## Close()

void Clip::Close | ( |  | ) |

override virtual

Close the internal reader.

Implements openshot::ReaderBase.

Definition at line 339 of file Clip.cpp.

Referenced by Clip(), and ~Clip().

## Effects()

std::list< openshot::EffectBase * > openshot::Clip::Effects | ( |  | ) |

inline

Return the list of effects on the timeline.

Definition at line 225 of file Clip.h.

## End() [1/2]

float Clip::End | ( |  | ) | const

override virtual

Get end position (in seconds) of clip (trim end of video), which can be affected by the time curve.

Reimplemented from openshot::ClipBase.

Definition at line 354 of file Clip.cpp.

Referenced by openshot::CVObjectDetection::detectObjectsClip(), PropertiesJSON(), CVStabilization::stabilizeClip(), and openshot::CVTracker::trackClip().

## End() [2/2]

void Clip::End | ( | float | value | ) |

override virtual

Set end position (in seconds) of clip (trim end of video)

Reimplemented from openshot::ClipBase.

Definition at line 376 of file Clip.cpp.

## GetAttachedClip()

Clip * openshot::Clip::GetAttachedClip | ( |  | ) | const

inline

Return a pointer to the clip this clip is attached to.

Definition at line 212 of file Clip.h.

## GetAttachedId()

std::string openshot::Clip::GetAttachedId | ( |  | ) | const

inline

Get and set the object id that this clip is attached to.

Definition at line 198 of file Clip.h.

## GetAttachedObject()

std::shared_ptr< openshot::TrackedObjectBase > openshot::Clip::GetAttachedObject | ( |  | ) | const

inline

Return a pointer to the trackedObject this clip is attached to.

Definition at line 210 of file Clip.h.

## GetCache()

openshot::CacheMemory * openshot::Clip::GetCache | ( |  | ) |

inline override virtual

Get the cache object (always return NULL for this reader)

Implements openshot::ReaderBase.

Definition at line 192 of file Clip.h.

## GetEffect()

openshot::EffectBase * Clip::GetEffect | ( | const std::string & | id | ) |

Look up an effect by ID.

Definition at line 470 of file Clip.cpp.

## GetFrame() [1/3]

std::shared_ptr< Frame > Clip::GetFrame | ( | int64_t | clip_frame_number | ) |

override virtual

Get an openshot::Frame object for a specific frame number of this clip. The image size and number of samples match the source reader.

Returns
  A new openshot::Frame object

Parameters

  clip_frame_number | The frame number (starting at 1) of the clip

Implements openshot::ClipBase.

Definition at line 389 of file Clip.cpp.

Referenced by openshot::CVObjectDetection::detectObjectsClip(), GetFrame(), openshot::ObjectDetection::GetFrame(), openshot::Tracker::GetFrame(), GetFrame(), CVStabilization::stabilizeClip(), and openshot::CVTracker::trackClip().

## GetFrame() [2/3]

std::shared_ptr< Frame > Clip::GetFrame | ( | std::shared_ptr< openshot::Frame > | background_frame,
|  | int64_t | clip_frame_number
| ) |  |

override virtual

Get an openshot::Frame object for a specific frame number of this clip. The image size and number of samples match the background_frame passed in and the timeline (if available).

A new openshot::Frame objects is returned, based on a copy from the source image, with all keyframes and clip effects rendered/rasterized.

Returns
  The modified openshot::Frame object

Parameters

  background_frame | The frame object to use as a background canvas (i.e. an existing Timeline openshot::Frame instance)
  clip_frame_number | The frame number (starting at 1) of the clip. The image size and number of samples match the background_frame passed in and the timeline (if available)

Implements openshot::ClipBase.

Definition at line 397 of file Clip.cpp.

## GetFrame() [3/3]

std::shared_ptr< Frame > Clip::GetFrame | ( | std::shared_ptr< openshot::Frame > | background_frame,
|  | int64_t | clip_frame_number,
|  | openshot::TimelineInfoStruct * | options
| ) |  |

Get an openshot::Frame object for a specific frame number of this clip. The image size and number of samples match the background_frame passed in and the timeline (if available).

A new openshot::Frame objects is returned, based on a copy from the source image, with all keyframes and clip effects rendered/rasterized.

Returns
  The modified openshot::Frame object

Parameters

  background_frame | The frame object to use as a background canvas (i.e. an existing Timeline openshot::Frame instance)
  clip_frame_number | The frame number (starting at 1) of the clip on the timeline. The image size and number of samples match the timeline.
  options | The openshot::TimelineInfoStruct pointer, with more details about this specific timeline clip, such as, if it's a top clip. This info is used to apply global transitions and masks, if needed.

Definition at line 404 of file Clip.cpp.

## init_reader_rotation()

void Clip::init_reader_rotation | ( |  | ) |

protected

Update default rotation from reader.

Definition at line 115 of file Clip.cpp.

Referenced by init_reader_settings().

## init_reader_settings()

void Clip::init_reader_settings | ( |  | ) |

protected

Init reader info details.

Definition at line 101 of file Clip.cpp.

Referenced by Clip(), Clip(), init_settings(), and Reader().

## init_settings()

void Clip::init_settings | ( |  | ) |

protected

Init default settings for a clip.

Definition at line 36 of file Clip.cpp.

Referenced by Clip(), Clip(), and Clip().

## IsOpen()

bool openshot::Clip::IsOpen | ( |  | ) |

inline override virtual

Determine if reader is open or closed.

Implements openshot::ReaderBase.

Definition at line 195 of file Clip.h.

## Json()

std::string Clip::Json | ( |  | ) | const

override virtual

Generate JSON string of this object.

Implements openshot::ClipBase.

Definition at line 735 of file Clip.cpp.

## JsonValue()

Json::Value Clip::JsonValue | ( |  | ) | const

override virtual

Generate Json::Value for this object.

Implements openshot::ClipBase.

Definition at line 889 of file Clip.cpp.

Referenced by Json().

## Name()

std::string openshot::Clip::Name | ( |  | ) |

inline override virtual

Return the type name of the class.

Implements openshot::ReaderBase.

Definition at line 215 of file Clip.h.

## Open()

void Clip::Open | ( |  | ) |

override virtual

Open the internal reader.

Implements openshot::ReaderBase.

Definition at line 318 of file Clip.cpp.

Referenced by Clip(), openshot::CVObjectDetection::detectObjectsClip(), CVStabilization::stabilizeClip(), and openshot::CVTracker::trackClip().

## ParentTimeline() [1/2]

openshot::TimelineBase * openshot::Clip::ParentTimeline | ( |  | ) |

inline override virtual

Get the associated Timeline pointer (if any)

Reimplemented from openshot::ClipBase.

Definition at line 276 of file Clip.h.

Referenced by AddEffect(), AttachToObject(), and openshot::Timeline::SetJsonValue().

## ParentTimeline() [2/2]

void Clip::ParentTimeline | ( | openshot::TimelineBase * | new_timeline | ) |

override virtual

Set associated Timeline pointer.

Reimplemented from openshot::ClipBase.

Definition at line 381 of file Clip.cpp.

## PropertiesJSON()

std::string Clip::PropertiesJSON | ( | int64_t | requested_frame | ) | const

override virtual

Get all properties for a specific frame (perfect for a UI to display the current state of all properties at any time)

Implements openshot::ClipBase.

Definition at line 742 of file Clip.cpp.

## Reader() [1/2]

ReaderBase * Clip::Reader | ( |  | ) |

Get the current reader.

Definition at line 308 of file Clip.cpp.

Referenced by SetJsonValue().

## Reader() [2/2]

void Clip::Reader | ( | openshot::ReaderBase * | new_reader | ) |

Set the current reader.

Parameters

  new_reader | The reader to be used by this clip

Definition at line 272 of file Clip.cpp.

Referenced by openshot::CVObjectDetection::detectObjectsClip(), CVStabilization::stabilizeClip(), and openshot::CVTracker::trackClip().

## RemoveEffect()

void Clip::RemoveEffect | ( | openshot::EffectBase * | effect | ) |

Remove an effect from the clip.

Parameters

  effect | Remove an effect from the clip.

Definition at line 1197 of file Clip.cpp.

## SetAttachedClip()

void Clip::SetAttachedClip | ( | Clip * | clipObject | ) |

Set the pointer to the clip this clip is attached to.

Definition at line 267 of file Clip.cpp.

Referenced by AttachToObject().

## SetAttachedId()

void openshot::Clip::SetAttachedId | ( | std::string | value | ) |

inline

Set id of the object id that this clip is attached to.

Definition at line 200 of file Clip.h.

## SetAttachedObject()

void Clip::SetAttachedObject | ( | std::shared_ptr< openshot::TrackedObjectBase > | trackedObject | ) |

Set the pointer to the trackedObject this clip is attached to.

Definition at line 262 of file Clip.cpp.

Referenced by AttachToObject().

## SetJson()

void Clip::SetJson | ( | const std::string | value | ) |

override virtual

Load JSON string into this object.

Implements openshot::ClipBase.

Definition at line 945 of file Clip.cpp.

## SetJsonValue()

void Clip::SetJsonValue | ( | const Json::Value | root | ) |

override virtual

Load Json::Value into this object.

Implements openshot::ClipBase.

Definition at line 962 of file Clip.cpp.

Referenced by SetJson(), and openshot::Timeline::SetJsonValue().

## Waveform() [1/2]

bool openshot::Clip::Waveform | ( |  | ) |

inline

Get the waveform property of this clip.

Definition at line 294 of file Clip.h.

## Waveform() [2/2]

void openshot::Clip::Waveform | ( | bool | value | ) |

inline

Set the waveform property of this clip.

Definition at line 295 of file Clip.h.

## Member Data Documentation

## alpha

openshot::Keyframe openshot::Clip::alpha

Curve representing the alpha (1 to 0)

Definition at line 302 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## anchor

openshot::AnchorType openshot::Clip::anchor

The anchor determines what parent a clip should snap to.

Definition at line 167 of file Clip.h.

Referenced by init_settings(), JsonValue(), and SetJsonValue().

## channel_filter

openshot::Keyframe openshot::Clip::channel_filter

A number representing an audio channel to filter (clears all other channels)

Definition at line 329 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## channel_mapping

openshot::Keyframe openshot::Clip::channel_mapping

A number representing an audio channel to output (only works when filtering a channel)

Definition at line 330 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## COMPILED_WITH_CV

bool openshot::Clip::COMPILED_WITH_CV = true

Definition at line 172 of file Clip.h.

## display

openshot::FrameDisplayType openshot::Clip::display

The format to display the frame number (if any)

Definition at line 168 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## getFrameMutex

std::recursive_mutex openshot::Clip::getFrameMutex

protected

Mutex for multiple threads.

Definition at line 92 of file Clip.h.

## gravity

openshot::GravityType openshot::Clip::gravity

The gravity of a clip determines where it snaps to its parent.

Definition at line 165 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## has_audio

openshot::Keyframe openshot::Clip::has_audio

An optional override to determine if this clip has audio (-1=undefined, 0=no, 1=yes)

Definition at line 333 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## has_video

openshot::Keyframe openshot::Clip::has_video

An optional override to determine if this clip has video (-1=undefined, 0=no, 1=yes)

Definition at line 334 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## location_x

openshot::Keyframe openshot::Clip::location_x

Curve representing the relative X position in percent based on the gravity (-1 to 1)

Definition at line 300 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## location_y

openshot::Keyframe openshot::Clip::location_y

Curve representing the relative Y position in percent based on the gravity (-1 to 1)

Definition at line 301 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## mixing

openshot::VolumeMixType openshot::Clip::mixing

What strategy should be followed when mixing audio with other clips.

Definition at line 169 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## origin_x

openshot::Keyframe openshot::Clip::origin_x

Curve representing X origin point (0.0=0% (left), 1.0=100% (right))

Definition at line 308 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## origin_y

openshot::Keyframe openshot::Clip::origin_y

Curve representing Y origin point (0.0=0% (top), 1.0=100% (bottom))

Definition at line 309 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## perspective_c1_x

openshot::Keyframe openshot::Clip::perspective_c1_x

Curves representing X for coordinate 1.

Definition at line 319 of file Clip.h.

Referenced by init_settings(), JsonValue(), and SetJsonValue().

## perspective_c1_y

openshot::Keyframe openshot::Clip::perspective_c1_y

Curves representing Y for coordinate 1.

Definition at line 320 of file Clip.h.

Referenced by init_settings(), JsonValue(), and SetJsonValue().

## perspective_c2_x

openshot::Keyframe openshot::Clip::perspective_c2_x

Curves representing X for coordinate 2.

Definition at line 321 of file Clip.h.

Referenced by init_settings(), JsonValue(), and SetJsonValue().

## perspective_c2_y

openshot::Keyframe openshot::Clip::perspective_c2_y

Curves representing Y for coordinate 2.

Definition at line 322 of file Clip.h.

Referenced by init_settings(), JsonValue(), and SetJsonValue().

## perspective_c3_x

openshot::Keyframe openshot::Clip::perspective_c3_x

Curves representing X for coordinate 3.

Definition at line 323 of file Clip.h.

Referenced by init_settings(), JsonValue(), and SetJsonValue().

## perspective_c3_y

openshot::Keyframe openshot::Clip::perspective_c3_y

Curves representing Y for coordinate 3.

Definition at line 324 of file Clip.h.

Referenced by init_settings(), JsonValue(), and SetJsonValue().

## perspective_c4_x

openshot::Keyframe openshot::Clip::perspective_c4_x

Curves representing X for coordinate 4.

Definition at line 325 of file Clip.h.

Referenced by init_settings(), JsonValue(), and SetJsonValue().

## perspective_c4_y

openshot::Keyframe openshot::Clip::perspective_c4_y

Curves representing Y for coordinate 4.

Definition at line 326 of file Clip.h.

Referenced by init_settings(), JsonValue(), and SetJsonValue().

## previous_location

AudioLocation openshot::Clip::previous_location

protected

Previous time-mapped audio location.

Definition at line 95 of file Clip.h.

## rotation

openshot::Keyframe openshot::Clip::rotation

Curve representing the rotation (0 to 360)

Definition at line 305 of file Clip.h.

Referenced by init_reader_rotation(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## scale

openshot::ScaleType openshot::Clip::scale

The scale determines how a clip should be resized to fit its parent.

Definition at line 166 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## scale_x

openshot::Keyframe openshot::Clip::scale_x

Curve representing the horizontal scaling in percent (0 to 1)

Definition at line 298 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## scale_y

openshot::Keyframe openshot::Clip::scale_y

Curve representing the vertical scaling in percent (0 to 1)

Definition at line 299 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## shear_x

openshot::Keyframe openshot::Clip::shear_x

Curve representing X shear angle in degrees (-45.0=left, 45.0=right)

Definition at line 306 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## shear_y

openshot::Keyframe openshot::Clip::shear_y

Curve representing Y shear angle in degrees (-45.0=down, 45.0=up)

Definition at line 307 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## time

openshot::Keyframe openshot::Clip::time

Curve representing the frames over time to play (used for speed and direction of video)

Definition at line 312 of file Clip.h.

Referenced by End(), openshot::FrameMapper::GetFrame(), init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## volume

openshot::Keyframe openshot::Clip::volume

Curve representing the volume (0 to 1)

Definition at line 313 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## wave_color

openshot::Color openshot::Clip::wave_color

Curve representing the color of the audio wave form.

Definition at line 316 of file Clip.h.

Referenced by init_settings(), JsonValue(), PropertiesJSON(), and SetJsonValue().

The documentation for this class was generated from the following files:

- Clip.h
- Clip.cpp